//
// GUI Transfer Toolkit - GTT (c) 2010 Hernan Ochoa (hernan@ampliasecurity.com)
//
// Filename: gtt_fastupload_server_citrix.cs

using System;
using System.Timers;
using System.Text;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;


namespace gtt
{

	

	public class Form1 : System.Windows.Forms.Form
	{
	private const int WM_UPLOAD_MAGIC				= (int)0x313;
	private const uint STATE_MARKER_PSYNC				= (uint)0x8A8A8A8A;
	private	const int STATE_WAITING				= (int)0;
	private	const int STATE_WAITING_FOR_FILENAME_LEN		= (int)1;
	private	const int STATE_WAITING_FOR_FILENAME			= (int)2;
	private	const int STATE_WAITING_FOR_FILE_LEN			= (int)3;
	private	const int STATE_WAITING_FOR_FILE_CONTENT		= (int)4;

	private string g_banner = "gtt_fastupload_server_citrix v1.0 - (c) 2010 Hernan Ochoa (hernan@ampliasecurity.com)";
	private string outfilename;
	private int g_state	= STATE_WAITING;
	private uint g_length	= 0;
	private uint g_count 	= 0;
	private uint g_inside   = 0;



		public Form1()
		{
			this.Text = "GTT_FASTUPLOAD_WINDOW";
			//base.InitializeComponent();

		}

		protected override void WndProc(ref Message m)
		{
		uint wparam, lparam;

			wparam = (uint)m.WParam.ToInt32();
			lparam = (uint)m.LParam.ToInt32();

			lock(this) {
			switch(m.Msg) {

				case WM_UPLOAD_MAGIC:
					if(g_inside == 1) return;
					g_inside=1;

					switch(g_state) {
						case STATE_WAITING:
							if( wparam == STATE_MARKER_PSYNC && lparam == STATE_MARKER_PSYNC) {
								g_count = 0;
								g_length = 0;
								outfilename = "";
								g_state = STATE_WAITING_FOR_FILENAME_LEN;
							}
							g_inside=0;
						return;

						case STATE_WAITING_FOR_FILENAME_LEN:
							if( wparam == STATE_MARKER_PSYNC) {
								if( lparam < 1024 ) {
									g_length = lparam;
									g_count = 0;
									g_state = STATE_WAITING_FOR_FILENAME;
								}	
							}
							g_inside=0;
						return;

						case STATE_WAITING_FOR_FILENAME:
							if( (g_count <= g_length) )
							{
								outfilename += Char.ConvertFromUtf32((int)wparam&0x000000ff);
								outfilename += Char.ConvertFromUtf32((int)(wparam&0x0000ff00)>>8);
								outfilename += Char.ConvertFromUtf32((int)(wparam&0x00ff0000)>>16);
								outfilename += Char.ConvertFromUtf32((int)(wparam>>24));
								outfilename += Char.ConvertFromUtf32((int)lparam&0x000000ff);
								outfilename += Char.ConvertFromUtf32((int)(lparam&0x0000ff00)>>8);
								outfilename += Char.ConvertFromUtf32((int)(lparam&0x00ff0000)>>16);
								outfilename += Char.ConvertFromUtf32((int)(lparam>>24));
								g_count+=8;
							}

							if( g_count >= g_length) {	
								outfilename = outfilename.Substring(0,(int)g_length);
								g_count = 0;
								g_state = STATE_WAITING_FOR_FILE_LEN;
							}
							g_inside=0;
						return;

						case STATE_WAITING_FOR_FILE_LEN:
							if( wparam == STATE_MARKER_PSYNC ) {
								g_length = lparam;
								g_count = 0;
								g_state = STATE_WAITING_FOR_FILE_CONTENT;
							}
						g_inside = 0;
						return;

						case STATE_WAITING_FOR_FILE_CONTENT:
							if( g_count < g_length )
							{
								
								FileStream file = new FileStream(outfilename, FileMode.Append, FileAccess.Write);
								BinaryWriter bw = new BinaryWriter(file);

								if( g_count < g_length ) {
									bw.Write((byte)(wparam&0x000000ff));
									g_count++;
								}
								if( g_count < g_length ) {
									bw.Write((byte)((wparam&0x0000ff00)>>8));
									g_count++;
								}

								if( g_count < g_length ) {
									bw.Write((byte)((wparam&0x00ff0000)>>16));
									g_count++;
								}	

								if( g_count < g_length ) {
									bw.Write((byte)(wparam>>24));
									g_count++;
								}

								if( g_count < g_length ) {
									bw.Write((byte)(lparam&0x000000ff));
									g_count++;
								}

								if( g_count < g_length ) {
									bw.Write((byte)((lparam&0x0000ff00)>>8));
									g_count++;
								}	

								if( g_count < g_length ) {
									bw.Write((byte)((lparam&0x00ff0000)>>16));
									g_count++;
								}

								if( g_count < g_length ) {
									bw.Write((byte)(lparam>>24));
									g_count++;
								}

								bw.Close();

							}

							if( g_count >= g_length ) {
								MessageBox.Show("File Uploaded!", "GTT - FastUpload");
								g_state = STATE_WAITING;
							}

						g_inside = 0;
						return;


					}
				break;
			}

			}
			base.WndProc(ref m);
			g_inside = 0;
		}	
		[STAThread]
		static void Main()
		{
			Application.Run(new Form1());
		}	
	}

}
